{   Unidade trata de extracao de bloco do Dicionrio   }
{   Autor :  Marcelo Luis Pimentel Pinheiro     }

Unit DicBloco;

Interface

Uses WinDOWS, sysutils, DVCRT, DVWin, DVarq,
DicVars, Dicsom, Dicler;

Procedure Gravabloco;
Procedure TratablocoInfo;
Procedure Tratabloco;
Procedure InicBloco;
Procedure BlocoLinha;
Procedure BlocoUma;
Procedure BlocoDuas;
Procedure BlocoTres;
Procedure BlocoQuatro;
Procedure BlocoCinco;
Procedure BlocoSeis;
Procedure BlocoSete;
Procedure BlocoOito;
Procedure BlocoNove;
Procedure BlocoDez;
Procedure BlocoVinte;
Procedure BlocoCapitulo;
Procedure BlocoLivro;
Procedure BlocoDicionario;
Procedure AdicionaBloco;
procedure gravaProcura;

Implementation

var
    a : text;
   arquibloco : String;
    sz: array [0..144] of char;
c: char;
    nomedoarquivo, salvanome: string;

Procedure InicBloco;
begin
Inibloco :=0;
Fimbloco :=0;
end;

{-----------------------------}

Procedure BlocoLinha;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py);
    msgbaixo('DCBLKLIN', 'Bloco linha');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoUma;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+1;
    msgbaixo('DCBLKUMA', 'Uma Linha');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoDuas;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+2;
    msgbaixo('DCBLKDUA', 'Duas Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoTres;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+3;
    msgbaixo('DCBLKTRE', 'Tres Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoQuatro;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+4;
    msgbaixo('DCBLKQUA', 'Quatro Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoCinco;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+5;
    msgbaixo('DCBLKCIN', 'Cinco Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoSeis;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+6;
    msgbaixo('DCBLKSEI', 'Seis Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoSete;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+7;
    msgbaixo('DCBLKSET', 'Sete Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoOito;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+8;
    msgbaixo('DCBLKOIT', 'Oito Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoNove;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+9;
    msgbaixo('DCBLKNOV', 'Nove Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}

Procedure BlocoDez;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+10;
    msgbaixo('DCBLKDEZ', 'Dez Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;


{-----------------------------}

Procedure BlocoVinte;
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    end;
end;

begin
    fimbloco := ponteiro + pred(py)+19;
    msgbaixo('DCBLKVIN', 'Vinte Linhas');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
    end;

{-----------------------------}


Procedure BlocoCapitulo;
begin
    inibloco := py;
inibloco :=0;
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end;

      If (codlivro = 26) and (capituloatual =13) then
begin
capituloatual := capituloatual;
    inibloco := py;
  ponteiro := indice[codlivro];
inibloco :=(ponteiro+ InicioUltimaParte)-9;
    fimbloco :=(ponteiro+TamanhoLetraZ)-9;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
end
else

begin
  seek(arquivo, indice[codlivro]);
  inc(capituloatual);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;

      If codlivro <> 1 then
capituloatual := capituloatual-1
else

      If codlivro = 1 then
  dec(capituloatual);
begin
if capituloatual =26 then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end
else
begin
    ponteiro :=filepos(arquivo)-3;
    fimbloco := ponteiro;
capituloatual := capituloatual;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;
end;

      If (codlivro = 2) or (capituloatual =23) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 3) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 4) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 5) or (capituloatual =27) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 6) or (capituloatual =20) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 7) or (capituloatual =19) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 8) or (capituloatual =23) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 9) or (capituloatual =24) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 10) or (capituloatual =11) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 11) or (capituloatual =22) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 12) or (capituloatual =20) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 13) or (capituloatual =22) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 14) or (capituloatual =23) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 15) or (capituloatual =25) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 16) or (capituloatual =25) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 17) or (capituloatual =18) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 18) or (capituloatual =21) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 19) or (capituloatual =25) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 20) or (capituloatual =25) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 21) or (capituloatual =21) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 22) or (capituloatual =17) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 23) or (capituloatual =19) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 24) or (capituloatual =11) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 25) or (capituloatual =18) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

      If (codlivro = 26) or (capituloatual =13) then
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

begin
    ponteiro :=filepos(arquivo)-3;
    fimbloco := ponteiro;
    msgbaixo('DCBLKCAP', 'Bloco Captulo');
exit;
end;

end;
end;

{-----------------------------}

Procedure BlocoLivro;
var salvaPy: LongInt;
begin
salvaPy := py;
    inibloco := py;
inibloco := 0;

    capituloatual := numerocap[codlivro] ;
  ponteiro := indice[codlivro]+1;
    capituloatual := 1;
    inibloco :=ponteiro;

begin
      If codlivro = 26  then
begin
  ponteiro := indice[codlivro];
    fimbloco :=(ponteiro+TamanhoLetraZ)-9;
end
else
begin
  ponteiro := indice[codlivro+1]-3;
    fimbloco := ponteiro;
end;
end;

    msgbaixo('DCBLKLIV', 'Bloco Livro');

                    ponteiro :=filepos(arquivo)-11;
    py:=salvaPy;
    atualizaporindice;

                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

{--------------------------------------------------------}

Procedure BlocoDicionario;
var salvaPy: LongInt;
begin
salvaPy := py;
    inibloco := py;
inibloco := 0;

    capituloatual := numerocap[1] ;
  ponteiro := indice[1]+1;
    capituloatual := 1;
    inibloco :=ponteiro;
    titulolerinibloco := 'A -PARTE-1';

codlivro := 1;
  ponteiro := indice[26];
    fimbloco :=(ponteiro+TamanhoLetraZ)-21;

    msgbaixo('DCBLKDIC', 'Bloco Dicionrio');

                    ponteiro :=filepos(arquivo)-11;
    py:=salvaPy;

                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

{--------------------------------------------------------}

procedure falaTamanhoArq (tam: longint);
var
    medida: string;
    decimal: integer;
begin

    if tam >= 1024*1024 then
        begin
            medida := 'Mb';
            tam := tam div 1024;
            tam := tam div 1024;
        end;

begin
    if tam >= 65536 then
        begin
            medida := 'K';
            decimal := tam mod 1024;
            tam := tam div 1024;
            if decimal > 512 then tam := tam + 1;
        end;
        end;

if (medida <> 'Mb') and
(medida <> 'K') then
medida := 'bytes';

//    fala ('EDTOTAL'); {'Total: '}
    if tam = 0 then
        sintCarac ('0')    // corrige erro no sintetizador L&H
    else
        sintWrite (intToStr (tam) + medida);
end;

{--------------------------------------------------------}
{                mostra dados de arquivo
{--------------------------------------------------------}

procedure mostraDadosArq (arquibloco: string);
const
    tabDias: array [1..7] of string =
        ('Domingo', 'Segunda', 'Tera', 'Quarta', 'Quinta', 'Sexta', 'Sbado');
var
    srec: TSearchRec;
begin
    sintWriteln (arquibloco);
    if FindFirst(arquibloco, faAnyFile, srec) <> 0 then
        begin
            fala ('EDINDISP');   {'Dado no disponvel'}
            exit;
        end;

    if (fileGetAttr (srec.FindData.cFileName) and faReadOnly) <> 0 then
         fala ('EDPRO');    { Protegido }

    falaTamanhoArq (srec.Size);
    writeln;

//    fala ('EDDATCRI');
sintWriteln (tabDias [dayOfWeek (FileDateToDateTime(srec.Time))]
        + ' ' + dateToStr (FileDateToDateTime(srec.Time))
        + ' ' + timeToStr (FileDateToDateTime(srec.Time)));
    writeln;

    findClose (srec);
end;

{--------------------------------------------------------}

Procedure GravaBloco;
var
    resp, c2: char;
    cor: integer;
    novoNome: string;

label inicio, fechaArq;
begin
  gotoxy(2,8); write(limpeza);
gotoxy(10, 8);

Inicio :
    nomeArquivo := sintAmbiente ('EDIVOX', 'NOMEDOARQUIVO');
    if nomeArquivo = '' then
        begin
            nomeArquivo := '';
        end;

    arquibloco := nomeArquivo;
  write ('Qual o nome do arquivo ? ');
  sintsom ('DCQUEARQ'); {'Qual o nome do arquivo?'}
    begin
    sintetiza (arquibloco);
    c := sintEdita (arquibloco, wherex, wherey, 255, true);
            arquibloco := compactaLinha (arquibloco);
    writeln;

    if arquibloco = '' then
    arquibloco := nomeArquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

    if c = ESC then
                begin
    msgbaixo ('DCDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
        begin
    msgbaixo ('DCDESIST', 'Operao cancelada');
            exit;
        end;

    if (c = baix) or (c = cima) or (c = F9) then
begin
            arquibloco := obtemNomeArq (15);
            arquibloco := compactaLinha (arquibloco);

            if arquibloco = '' then
                begin
    msgbaixo ('DCDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
    arquibloco := nomeArquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

                end;

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);
                 msgbaixo ('DCREESCR', 'Quer reescrever arquivo?');
            sintLeTecla (resp, c2);

                 if upcase (resp) = #0 then
                begin
                    if c2 = F1 then
                        begin
                            cor := textAttr;
                            textColor (yellow);
//                            fala ('EDDARQNV'); {'Dados do novo arquivo'}
                            mostraDadosArq (arquibloco);
//                            fala ('EDDARQEX'); {'Dados do arquivo existente'}
                            mostraDadosArq (novoNome);
//                            sintBip; sintBip;
                            textAttr := cor;
                        end;
                    goto inicio;
                end;

                 if upcase (resp) <> 'S' then
                      begin
                          msgbaixo ('DCESCCAN', 'Gravao de arquivocancelada');
                          goto inicio;
                      end;
         end;
//    end;

    assign (a, arquibloco);
    {$i-} rewrite (a); {$I+}
    if ioresult <> 0 then
        begin
    msgbaixo('DCNOMINV', 'Nome de arquivo invlido');
            arquibloco := '';
            goto inicio;
        end;

begin
  atualizaPorIndice;
numerocap[codlivro] := (ponteiro + py -1);
  seek(arquivo, numerocap[codlivro]);
    writeln(a, '' +tituloler);
end;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
end;
  close(a);
{seek(arquivo, ponteiro);}
  msgbaixo ('DCARQGV', 'OK, arquivo gravado');
    arquibloco := salvaNome;
end;
end;

{-----------------------------}

function testaExtensao (nomeArq: string): boolean;
begin

    extPadrao := sintAmbiente ('EDIVOX', 'EXTENSAOPADRAO');
    if extPadrao = '' then
        begin
            extPadrao := '';
            strPCopy (sz, extPadrao);
            writePrivateProfileString('EDIVOX', 'EXTENSAOPADRAO',     sz, 'DOSVOX.INI');
        end;

    while (pos ('\', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('\', nomearq));
    while (pos ('/', nomeArq) <> 0) and (nomeArq <> '') do
        delete (nomeArq, 1, pos ('/', nomearq));

    if pos ('.', nomeArq) <> 0 then
        testaExtensao := true
    else
        testaExtensao := false;
end;

{-----------------------------}

Procedure adicionabloco;

Label Inicio, fecha, fim;
begin
  gotoxy(2,8); write(limpeza);
gotoxy(10, 8);

    nomedoarquivo := sintAmbiente ('EDIVOX', 'NOMEDOARQUIVO');
    if nomedoarquivo = '' then
        begin
            nomedoarquivo := '';
        end;

    salvanome := arquibloco;
    arquibloco := nomedoarquivo;
Inicio :
  write ('Qual o arquivo a aionar : ');
  sintsom('DCQUEADC');
    sintetiza (arquibloco);
    c := sintEdita (arquibloco, wherex, wherey, 255, true);
            nomearquivo := compactaLinha (nomearquivo);
    writeln;

    if arquibloco = '' then
    arquibloco := nomedoarquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

    if c = ESC then
                begin
    msgbaixo ('DCDESIST', 'Operao cancelada');
            goto fim;
                end;

    if arquibloco = '' then
    begin
    msgbaixo('DCDESIST', 'Operao cancelada');
            goto fim;
        end;

    if (c = baix) or (c = cima) or (c = F9) then
begin
            arquibloco := obtemNomeArq (15);
            nomearquivo := compactaLinha (nomearquivo);

            if arquibloco = '' then
                begin
    msgbaixo ('DCDESIST', 'Operao cancelada');
                    exit;
                end;

    if arquibloco = '' then
    arquibloco := nomedoarquivo;
            strPCopy (sz, arquibloco);
            writePrivateProfileString('EDIVOX', 'NOMEDOARQUIVO',     sz, 'DOSVOX.INI');

                end;

    if not testaExtensao (arquibloco) then
        begin
            assign (a, arquibloco);
            {$i-} reset (a); {$i+}
            if ioresult = 0 then
                {$i-} close (a) {$i+}
            else
               if extPadrao <> '' then
    begin
                arquibloco := arquibloco + '.' + extPadrao;
    end
    else
                arquibloco := arquibloco;
        end;

assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    msgbaixo('DCNOMINV', 'Nome de arquivo invlido');
            goto inicio;
    end;

begin
  atualizaPorIndice;
numerocap[codlivro] := (ponteiro + py -1);
  seek(arquivo, numerocap[codlivro]);
    writeln(a, '');
    writeln(a, '' + tituloler);
end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
    end;

fecha:
    {$I-}  close (a);  {$I+}
    if ioresult = 0 then
msgbaixo('DCARQADC', 'OK, arquivo adicionado');

fim:
    arquibloco := salvaNome;
End;

{-----------------------------}

procedure gravaProcura;
var fori:Byte;
    textoAProcurar, textoBuscado, dirGrava, s1: string;
    k: integer;
begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

                    dirGrava := sintAmbiente ('DICVOX', 'DIRGRAVA');
                    if dirGrava = '' then dirGrava := '.';
                    if dirGrava [length(dirGrava)] <> '\' then
                        dirGrava := dirGrava + '\';

    s1 := sintAmbiente ('DICVOX', 'DICATU');
    if s1 = 'A' then
    begin
s1 := ('A - Dicionrio Jurdico de Latim');
    end;

    if s1 = 'B' then
    begin
s1 := ('B - Dicionrio da Bblia de Almeida');
    end;

    if s1 = 'C' then
    begin
s1 := ('C - Dicionrio de Sociologia');
    end;

    if s1 = 'D' then
    begin
s1 := ('D - Espanhol - Portugus - Espanhol');
    end;

    if s1 = 'E' then
    begin
s1 := ('E - Espanhol - Espanhol');
    end;

    if s1 = 'F' then
    begin
s1 := ('F - Francs - Portugus - Francs');
    end;

    if s1 = 'G' then
    begin
s1 := ('G - Dicionrio de Grego com Concordncia em grego nas informaes');
    end;

    if s1 = 'H' then
    begin
s1 := ('H - Dicionrio de Hebraico com Concordncia em hebraico nas informaes');
    end;

    if s1 = 'I' then
    begin
s1 := ('I - Ingls - Portugus - Ingls');
    end;

    if s1 = 'J' then
    begin
s1 := ('J - Dicionrio Jurdico Brasileiro');
    end;

    if s1 = 'K' then
    begin
s1 := ('K - Dicionrio de Eletrnica em espanhol');
    end;

    if s1 = 'L' then
    begin
s1 := ('L - Dicionrio de Filosofia');
    end;

    if s1 = 'M' then
    begin
s1 := ('M - Dicionrio de significado e origem dos nomes');
    end;

    if s1 = 'N' then
    begin
s1 := ('N - Dicionrio de Informtica');
    end;

    if s1 = 'O' then
    begin
s1 := ('O - Oxford');
    end;

    if s1 = 'P' then
    begin
s1 := ('P - Dicionrio de Portugus');
    end;

    if s1 = 'Q' then
    begin
s1 := ('Q - Dicionrio de Significados');
    end;

    if s1 = 'R' then
    begin
s1 := ('R - Dicionrio de Origem da Palavra');
    end;

    if s1 = 'S' then
    begin
s1 := ('S - Ingls - Espanhol');
    end;

    if s1 = 'T' then
    begin
s1 := ('T - Italiano - Portugus - Italiano');
    end;

    if s1 = 'U' then
    begin
s1 := ('U - Dicionrio de psicologia');
    end;

    if s1 = 'V' then
    begin
s1 := ('V - Alemo - Portugus');
    end;

    if s1 = 'W' then
    begin
s1 := ('W - Webster');
    end;

    if s1 = 'X' then
    begin
s1 := ('X - Esperanto - Portugus');
    end;

    if s1 = 'Y' then
    begin
s1 := ('Y - Vocabulrio Ortogrfico da Lngua Portuguesa (VOLP)');
    end;

    if s1 = 'Z' then
    begin
s1 := ('Z - Dicionrio de Qumica');
    end;

    if s1 = '1' then
    begin
s1 := ('1 - Portugus - Ingls - Portugus');
    end;

    if s1 = '2' then
    begin
s1 := ('2 - Dicionrio de Grego em portugus, com Concordncia em grego nas informaes');
    end;

    if s1 = '3' then
    begin
s1 := ('3 - Dicionrio de Hebraico em portugus, com Concordncia em hebraico nas informaes');
    end;

    if s1 = '4' then
    begin
s1 := ('4 - Portugus - Espanhol - Portugus');
    end;

    if s1 = '5' then
    begin
s1 := ('5 - Latim - Ingls - Latim');
    end;

    if s1 = '6' then
    begin
s1 := ('6 - Ingls - Latim - Ingls');
    end;

    if s1 = '7' then
    begin
s1 := ('7 - Portugus - Italiano - Portugus');
    end;

    if s1 = '8' then
    begin
s1 := ('8 - Etimolgico - Origem das Palavras');
    end;

    if s1 = '9' then
    begin
s1 := ('9 - Dicionrio Bblico da Torre de Vigia');
    end;

    if s1 = '0' then
    begin
s1 := ('0 - Dicionrio de Origem da Palavra');
    end;

        if gravaAsProcuras or (tecla = F12) then
begin
begin
pontaux:= ponteiro ;
If pontaux < 0  then pontaux:=0;
   seek(arquivo, pontaux);
    ponteiro := pontaux;
for fori := 1 to 11 do
  read(arquivo, texto[fori]);
end;

    inibloco := py;
inibloco :=0;
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end;

begin
    ponteiro :=filepos(arquivo)-1;
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end;

      If (codlivro = 26) and (capituloatual =22) then
begin
capituloatual := capituloatual-1;
    inibloco := py;
end;

begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;

begin
    ponteiro :=filepos(arquivo)-1;
    inibloco := ponteiro;
    fimbloco := ponteiro;
end;

begin


if tecla = F12 then
begin
arquiBloco := dirGrava + '0 ' + textoBuscado + ' Dicionrio ' + s1 + '.TXT';
  arquibloco :=limpa(  arquiBloco );
end
else
begin
    linhateste0 := linhateste;
    k := pos('-PARTE-', linhateste0);
    if k > 0 then
        delete(linhateste0, k, length(linhateste0)-k+1);
    linhateste := linhateste0;
linhateste := limpa(linhateste);
arquiBloco := dirGrava + '0 ' + textoBuscado + ' ' + linhateste + ' ' + capitulo + ' Dicionrio ' + s1 + '.TXT';
  arquibloco :=limpa(  arquiBloco );
end;

//arquiBloco := dirGrava + '0 ' + textoBuscado + '.TXT';
//  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    writeln(a, '');


    linhateste0 := linhateste;
    k := pos('-PARTE-', linhateste0);
    if k > 0 then
        delete(linhateste0, k, length(linhateste0)-k+1);
    linhateste := linhateste0;
    linhateste := trim (linhateste);
    writeln(a, '' + linhateste + ' ' + capitulo + ' "' + textoBuscado + '"' + ' Dicionrio ' + s1);

//linhateste := trim (linhateste);
//    writeln(a, '' + linhateste + ' "' + textoBuscado + '"');
    end;
close(a);
end;
end
else
Begin
             assign (a, arquibloco);
{$I-} rewrite(a);{$I+}
If IOresult <> 0  Then
    begin
    {$I-} close(a){$I+};
    exit;
    end;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);

    linhateste0 := linhateste;
    k := pos('-PARTE-', linhateste0);
    if k > 0 then
        delete(linhateste0, k, length(linhateste0)-k+1);
    linhateste := linhateste0;
    linhateste := trim (linhateste);
    writeln(a, '' + linhateste + ' ' + capitulo + ' "' + textoBuscado + '"' + ' Dicionrio ' + s1);

//linhateste := trim (linhateste);
//    writeln(a, '' + linhateste + ' "' + textoBuscado + '"');
end;
  close(a);
end;
end;
end;
ponteiro := pontaux;
letrecho;

begin
begin
begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py)-3;
    end;
    end;

begin
    fimbloco := ponteiro + pred(py)+11;
    end;
    end;

begin
if tecla = F12 then
begin
arquiBloco := dirGrava + '0 ' + textoBuscado + ' Dicionrio ' + s1 + '.TXT';
  arquibloco :=limpa(  arquiBloco );
end
else
begin
    linhateste0 := linhateste;
    k := pos('-PARTE-', linhateste0);
    if k > 0 then
        delete(linhateste0, k, length(linhateste0)-k+1);
    linhateste := linhateste0;
linhateste := limpa(linhateste);
arquiBloco := dirGrava + '0 ' + textoBuscado + ' ' + linhateste + ' ' + capitulo + ' Dicionrio ' + s1 + '.TXT';
  arquibloco :=limpa(  arquiBloco );
end;


//arquiBloco := dirGrava + '0 ' + textoBuscado + '.TXT';
//  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

seek(arquivo, inibloco);
while filepos(arquivo)<= fimbloco  do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
    end;
close(a);
end;
end
else
Begin
             assign (a, arquibloco);
{$I-} rewrite(a);{$I+}
If IOresult <> 0  Then
    begin
    {$I-} close(a){$I+};
    exit;
    end;

seek(arquivo, fimbloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, linhateste);
    linhateste := trim (linhateste);
    writeln(a, linhateste);
end;
  close(a);
end;
end;
end;
end
        else
            sintBip;
end;

{-----------------------------}

Procedure TratablocoInfo;
var c : char;
begin
gotoxy(2, 8); write(limpeza);
  gotoxy(10,8);
  write ('Comando de bloco : ');
  sintsom('DCCOMBLO');
c := readkey;

Case UPcase(c) Of
'I' : begin
    inibloco :=ponteiro + pred(py);
    write('Inicio do bloco');
    sintsom('DCINIBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'F' : begin
    fimbloco := ponteiro + pred(py);
    write('Fim do bloco');
    sintsom('DCFIMBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'A' : Adicionabloco;
'G' : GravaBloco;

else
             begin
    msgbaixo('DCDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end

end;
end;

{-----------------------------}

Procedure Tratabloco;
var c : char;
begin
gotoxy(2, 8); write(limpeza);
  gotoxy(10,8);
  write ('Comando de bloco : ');
  sintsom('DCCOMBLO');
c := readkey;

Case UPcase(c) Of

#27:
    begin
    msgbaixo('DCDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

'I' : begin
begin
  seek(arquivo, indice[codlivro]);
  str(capituloatual, capitulo);
  textoprocura := '-PARTE-'+capitulo;
  achou :=false;
  while not achou do
    begin
    read(arquivo, linhateste);
    achou :=pos(textoprocura, linhateste)>0;
    end;
end;

begin
    if ponteiro =filepos(arquivo)-1 then
begin
  ponteiro := ponteiro+1;
    inibloco := ponteiro;
  ponteiro := ponteiro-1;
end
else
    inibloco :=ponteiro + pred(py);
    write('Inicio do bloco');
    sintsom('DCINIBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;
end;

'F' : begin
    fimbloco := ponteiro + pred(py);
    write('Fim do bloco');
    sintsom('DCFIMBLO');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
    end;

'K' : begin
BlocoLinha;
    write('Bloco Linha');
end;

'1' : begin
BlocoUma;
    write('Uma Linha');
end;

'2' : begin
BlocoDuas;
    write('Duas Linhas');
end;

'3' : begin
BlocoTres;
    write('Trs Linhas');
end;

'4' : begin
BlocoQuatro;
    write('Quatro Linhas');
end;

'5' : begin
BlocoCinco;
    write('Cinco Linhas');
end;

'6' : begin
BlocoSeis;
    write('Seis Linhas');
end;

'7' : begin
BlocoSete;
    write('Sete Linhas');
end;

'8' : begin
BlocoOito;
    write('Oito Linhas');
end;

'9' : begin
BlocoNove;
    write('Nove Linhas');
end;

'D' : begin
BlocoDez;
    write('Bloco Bloco');
end;

'V' : begin
BlocoVinte;
    write('Bloco Maior');
end;

'B', 'T' : begin
BlocoDicionario;
    write('Bloco Dicionrio');
end;

//'C' : begin
//BlocoCapitulo;
//    write('Bloco Capitulo');
//end;

'L' : begin
BlocoLivro;
    write('Bloco Livro');
end;

'A' : Adicionabloco;

'G' : GravaBloco;


else
             begin
    msgbaixo('DCDESIST', 'Operao cancelada');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end

end;
end;

end.
