Unit DicLeitu;

Interface

uses DVHora, dvsapglb,
    DVCRT, WinDOWS, sysUtils, Dicsom, DVWin,
    Dicvars, Dicfun, DicBloco, Dicler,
    DicBusca, winprocs, wintypes, DVLenum;

procedure consisteDirArq;
Procedure ProcessaLeitura;
Procedure LeituraInfo;

Implementation
var lendoContinuo, iniciaLeitura: boolean;


procedure paramSintese;
var
    c, c2: char;
label fim;
begin
limpabaixo;
  gotoxy(10, 13); write('Qual a velocidade ? De 1 a 5: ');
  sintsom('DCVELOC');
    sintLeTecla (c, c2);
    writeln;
    if c in ['1'..'5'] then
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;

fim:
  sintsom('DCOK');
end;

{-------------------------------------------------------------}

function existeDir (dir: string): boolean;
var dirAtual: string;
begin
    getDir (0, dirAtual);
    {$I-}  chdir (dir);  {$I+}
    existeDir := ioresult = 0;
    chdir (dirAtual);
end;

{-------------------------------------------------------------}
{       consiste nome de diretrio da configurao
{-------------------------------------------------------------}

procedure consisteDirArq;
var erro: boolean;
    c, c2: char;
    confDirGra: shortString;
    s: string;
    sz: array [0..144] of char;
    dirAtual: string;
begin
    confDirGra  := (sintAmbiente('DICVOX', 'DIRGRAVA'));
    erro := false;
    if not existeDir (confDirGra) then
        begin
            msgbaixo ('DCERDGRA',  'Ateno! Diretrio de gravao inexistente');
            msgbaixo ('DCPOSCRI',   'Posso cri-lo? ');
            sintLeTecla (c, c2);
            writeln;
            if upcase(c) = 'N' then
                erro := true
            else
                begin
                     {$I-}  mkdir (confDirGra);  {$I+}
                     if ioresult <> 0 then
                         begin
                             erro := true;
                             msgbaixo ('DCDGNCRI',  'Diretrio de gravao no foi criado.');
                         end;
                end;
        end;

    if erro then
begin
         msgbaixo ('DCASDACI',  'Assumindo o diretrio de acionamento');
    getDir (0, dirAtual);
         sintWriteLn (dirAtual);

            s := '.';
            strPCopy (sz, s);
            writePrivateProfileString('DICVOX', 'DIRGRAVA',     sz, 'DOSVOX.INI');
end;
end;

{-----------------------------}

procedure selFala (nvoz: char);
var
    s: string;
    param: TParamVoz;
    velGeral, erro: integer;

    function extraiParam (var s: string): integer;
    var n: integer;
        negativo: integer;
    begin
        while (s <> '') and (s[1] = ' ') do delete (s, 1, 1);
        n := 0;

        negativo := 1;
        if (s <> '') and (s[1] = '-') then
            begin
                negativo := -1;
                delete (s, 1, 1);
            end;

        while (s <> '') and (s[1] in ['0'..'9']) do
            begin
                n := n * 10 + (ord(s[1]) - ord ('0'));
                delete (s, 1, 1);
            end;
        extraiParam := n * negativo;
    end;

begin
    s := sintAmbiente ('EDIVOX', 'VELOCIDADE');
    if (s = '') or (s = '0') then
        s := sintAmbiente ('TRADUTOR', 'VELOCIDADE');
    if s = '' then
        velGeral := 0
    else
        val (s, velGeral, erro);

    if nvoz = 'N' then
        sintReinic (velGeral, false, 3, 1, 1, 1)
    else
        begin
            s := sintAmbiente ('SAPIUTIL', 'VOZ'+nvoz);
            with param do
                begin
                    voz        := extraiParam (s);
                    velocidade := extraiParam (s);
                    tom        := extraiParam (s);
                    tipoSapi   := extraiParam (s);
                    if tipoSapi = 0 then tipoSapi := 4;

                    sintReinic (velGeral, true, tipoSapi, voz, velocidade, tom);
                end;
        end;
end;

{-----------------------------}

Procedure FalaVersao;
var s1: string;

begin
    s1 := sintAmbiente ('DICVOX', 'DICATU');
    if s1 = 'A' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCLATIM', 'A - Dicionrio Jurdico de Latim');
    end;

    if s1 = 'B' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDBAL', 'B - Dicionrio da Bblia de Almeida');
    end;

    if s1 = 'C' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCSOCI', 'C - Dicionrio de Sociologia');
    end;

    if s1 = 'D' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCESPPOR', 'D - Espanhol - Portugus - Espanhol');
    end;

    if s1 = 'E' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCESPA', 'E - Espanhol - Espanhol');
    end;

    if s1 = 'F' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCFRAN', 'F - Francs - Portugus - Francs');
    end;

    if s1 = 'G' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCGREGO', 'G - Dicionrio de Grego com Concordncia em grego nas informaes');
    end;

    if s1 = 'H' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCHEBRAI', 'H - Dicionrio de Hebraico com Concordncia em hebraico nas informaes');
    end;

    if s1 = 'I' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCINGPOR', 'I - ingls - Portugus - Ingls');
    end;

    if s1 = 'J' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDJBR', 'J - Dicionrio Jurdico Brasileiro');
    end;

    if s1 = 'K' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCELEESP', 'K - Dicionrio de Eletrnica em espanhol');
    end;

    if s1 = 'L' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCFILO', 'L - Dicionrio de Filosofia');
    end;

    if s1 = 'M' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCNOM', 'M - Dicionrio de significado e origem dos nomes');
    end;

    if s1 = 'N' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCINFO', 'N - Dicionrio de Informtica');
    end;

    if s1 = 'O' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCOXFORD', 'O - Oxford');
    end;

    if s1 = 'P' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCPOR', 'P - Dicionrio de Portugus');
    end;

    if s1 = 'Q' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCSIGN', 'Q - Dicionrio de Significados');
    end;

    if s1 = 'R' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDICORI', 'R - Dicionrio de Origem da Palavra');
    end;

    if s1 = 'S' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCINGESP', 'S - Ingls - Espanhol');
    end;

    if s1 = 'T' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCITAPOR', 'T - Italiano - Portugus - Italiano');
    end;

    if s1 = 'U' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCPSI', 'U - Dicionrio de psicologia');
    end;

    if s1 = 'V' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCALEPOR', 'V - Alemo - Portugus');
    end;

    if s1 = 'W' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCWEBSTE', 'W - Webster');
    end;

    if s1 = 'X' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCEPRPOR', 'X - Esperanto - Portugus');
    end;

    if s1 = 'Y' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCTER', 'Y - Vocabulrio Ortogrfico da Lngua Portuguesa (VOLP)');
    end;

    if s1 = 'Z' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCQUI', 'Z - Dicionrio de Qumica');
    end;

    if s1 = '1' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCPI', '1 - Portugus - Ingls - Portugus');
    end;

    if s1 = '2' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCGREG1', '2 - Dicionrio de Grego em portugus, com Concordncia em grego nas informaes');
    end;

    if s1 = '3' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCHEBRA1', '3 - Dicionrio de Hebraico em portugus, com Concordncia em hebraico nas informaes');
    end;

    if s1 = '4' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCPORESP', '4 - Portugus - Espanhol - Portugus');
    end;

    if s1 = '5' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCLATING', '5 - Latim - Ingls - Latim');
    end;

    if s1 = '6' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCINGLAT', '6 - Ingls - Latim - Ingls');
    end;

    if s1 = '7' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCPORITA', '7 - Portugus - Italiano - Portugus');
    end;

    if s1 = '8' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDICETI', '8 - Etimolgico - Origem das Palavras');
    end;

    if s1 = '9' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDICDTJ', '9 - Dicionrio Bblico da Torre de Vigia');
    end;

    if s1 = '0' then
    begin
        msgbaixo ('DCVERSAO', 'Verso'); sintWriteLn (' 15.3 '); msgbaixo ('DCDICPFR', '0 - Dicionrio de Origem da Palavra');
    end;

    end;

{-----------------------------}

procedure troca (var x1, x2: integer);
var temp: integer;
begin
    temp := x1;  x1 := x2;  x2 := temp;
end;

{-----------------------------}

procedure jogaAreaTransf (falando: boolean);
var i: integer;
    p: PChar;
textoClip: Linha;
    pos, tam: integer;
    tamAloc: integer;

begin
    if (iniMarca > 0) and (fimMarca > 0) then   // trechinho marcado
         begin
             getmem (p, 256);
             if iniMarca > fimMarca then troca(iniMarca, fimMarca);
             for i := 1 to (fimMarca-iniMarca) do
                 p[i-1] := texto[py][i+iniMarca-1];
             p [fimMarca-iniMarca] := #$0;
             putClipboard (p);
             freemem (p, 256);
             sintClek; sintClek;
    iniMarca := 1;
    fimMarca := 0;
    novoIni := 0;
                msgbaixo  ('DCBLKCRG',    'Bloco carregado');
             exit;
         end;

    if fimbloco = 0 then
        begin
            inibloco := py;
            fimBloco := py;
        end;

    if fimbloco < inibloco then
        msgbaixo ('DCBLKINV', 'Bloco invlido')
    else
        begin
            tamAloc := tamAloc  *100;   // para o NIL
            getmem (p, tamAloc);
            pos := 0;

    tituloler := titulolerinibloco;
            tam := length(tituloler);
                    move (tituloler[1], p[pos], tam);
pos := tam;
            p[pos] := #$0D;
            p[pos+1] := #$0A;
            pos := pos + 2;

seek(arquivo, inibloco);
While filepos(arquivo)<= fimbloco  Do
    begin
    read(arquivo, textoClip);
    textoClip := trim (textoClip);
    tam := length(textoClip);
                    if (longint (pos) + tam + 2) > tamAloc then   // nunca deve acontecer isso
                        begin
                            msgbaixo ('DCCOPTRU',   'cpia truncada');
                            break;
                        end;

                    move (textoClip[1], p[pos], tam);
                    pos := pos + tam;
                    p[pos]   := #$0d;
                    p[pos+1] := #$0a;
                    pos := pos + 2;
                end;

            p[pos] := #$0;

            putClipboard (p);
seek(arquivo, ponteiro);
                msgbaixo ('DCBLKCRG',   'Bloco carregado');

            freemem (p, tamAloc);
        end;

                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;

end;

{-----------------------------}

procedure lendo;
var
    x : byte;
    salva: integer;
    n: integer;
    sf: string;
begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

{-----------------------------}

PROCEDURE TRATACONTROLES;
var
c: char;
    salva: integer;
    n: integer;
    sf, s: string;
    apertouShift: boolean;

Begin

    apertouShift := GetKeyState(VK_SHIFT) < 0;
    if ((not apertouShift) and (tecla <> DEL)) or
       (tecla in [ALTF1, F3, F5, CTLF5, F6, CTLF6, F7, CTLF7, F9, F10,
        CTLPGUP, CTLPGDN, CIMA, BAIX, PGUP, PGDN, HOME, TEND]) then
        begin
            iniMarca := 0;
            fimMarca := 0;
        end
    else
        begin
            if iniMarca <= 0 then
                iniMarca := px;
        end;

    tecla := readkey;
    Case tecla of
    #15: Begin
            If ponteiro > 10  Then ponteiro :=ponteiro-10
            Else ponteiro :=3;

            px :=1;
            atualizaPorIndice;
            {sintclek;}
          end;

    F1:    falaPalavra;

    CTLF1: lendo;

CTLF2: begin
    s := sintAmbiente ('DICVOX', 'SAPIATIVADO');
    if (s <> '') and (upcase(s[1]) = 'S') then
begin
        velGeral := 3;
confVeloc := 2;
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
lendo;
end
else
begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
lendo;
end;
end;

CTLF3: begin
    s := sintAmbiente ('DICVOX', 'SAPIATIVADO');
    if (s <> '') and (upcase(s[1]) = 'S') then
begin
        velGeral := 3;
confVeloc := 4;
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
lendo;
end
else
begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
lendo;
end;
end;

CTLF4: begin
    s := sintAmbiente ('DICVOX', 'SAPIATIVADO');
    if (s <> '') and (upcase(s[1]) = 'S') then
begin
        velGeral := 3;
confVeloc := 6;
    sintReinic (velGeral, comSapi, confTipoSapi, confNum, confVeloc, confTonal);
lendo;
end
else
begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
lendo;
end;
end;

        ^F: Begin
                While Not Keypressed  Do
                Begin
                    If ponteiro > tamanhoDicionario-5  Then Exit;
                    falalinha(false);
                    If px >= Length (texto[py])  Then
                        px :=1;
                    inc(ponteiro);
                    escrevetelatexto;
                    atualizaporindice;
                end;
                while Keypressed Do tecla := readkey;
                tecla :=#255;
             end;

    F2: begin FalaLivroAtual;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F4: begin Paramsintese;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('DCFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
{        msgbaixo ('DCFIMTEX', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    F9: begin  VaiparaMarca;
                  FalaLivroAtual;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLF9: begin MarcaLivro;
                  FalaLivroAtual;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F5: buscaPalavra;
    CTLF5: buscaDeNovo;

    F6: begin VaiparaLivro;
falaLivroAtual;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLF6: begin
begin
    consisteDirArq;
    gravaAsProcuras := not gravaAsProcuras;
    if gravaAsProcuras then
        msgbaixo ('DCGRAVAN', 'Gravando as procuras')
    else
        msgbaixo ('DCSEMGRA', 'Sem gravar as procuras');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        {msgbaixo ('DCFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    F7: begin VaiParaCapitulo;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    F8: FalaHora;

    CTLF8: FalaDia;

    F11: begin
begin
    sintFalaPont := not sintFalaPont;
    if sintFalaPont then
        msgbaixo ('DCPONACI', 'Com pontos')
    else
        msgbaixo ('DCPONDLG', 'Sem pontos');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    F12, CTLF12: buscaRebusca;

    CTLPGUP: begin LivroAnterior;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLPGDN: begin LivroPosterior;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLHOME: begin IniLetra;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    CTLEND: begin FimLetra;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

CTLINS, INS: begin IniBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    DEL: begin FimBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        CTLDIR:  begin
                     salva := px;
                     palavraDir (true);
                     n := px-salva;
                     sf := copy (texto[py], salva, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;
        CTLESQ:  begin
                     salva := px;
                     palavraEsq (true);
                     n := salva-px;
                     sf := copy (texto[py], px, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;

    DIR:  setadir;

    ESQ: setaesq;

    CIMA: Begin Setacima; atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

    BAIX: begin Setabaixo; atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

    #113: VoltaNumber;

    #114: AvancaNumber;

    HOME: Begin
            px := 1;
            sintbip;
          end;

    TEND: Begin
            px := length( trim ( texto [py]))+1;
            sintbip;
          end;

    PGUP: begin voltaCapitulo;
py :=1;
px :=1;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    PGDN: begin pulaCapitulo;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    else  { of case }
            sintBip;
    end;

    if apertouShift then
         fimMarca := px;

End;

{-----------------------------}

Procedure ProcessaLeitura;
var x : byte;
    salva: integer;
    n: integer;
    sf, s1: string;

begin
  gotoxy(2,24); write(barraleitura);
  InicBloco;

  str(capituloatual, numlivro);
    tituloler :=nomelivros^[codlivro]+'-CAPITULO-'+numlivro;

if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                     escreveTelatexto;
if primeiraLetra (sintAmbiente ('BIBLIVOX', 'SAPIATIVADO')) = 'N' then
                        sintetiza (texto [py]);
                     atualizaporindice;
    repeat
            gotoxy (px, 09+py);

        tecla := readkey;
                Case tecla Of
                    { alt, ins, del, etc... }
                    #0: trataControles;

       '0':
        begin
                    selFala('N');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '1':
                    begin
                    selFala('1');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '2':
        begin
                    selFala('2');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '3':
        begin
                    selFala('3');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '4':
        begin
                    selFala('4');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '5':
        begin
                    selFala('5');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '6':
        begin
                    selFala('6');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '7':
        begin
                    selFala('7');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '8':
        begin
                    selFala('8');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

        '9':
        begin
                    selFala('9');
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('BVFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 66  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo ('BVFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

    ' ': begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTXT', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end
else
             end;

        'a','A': begin AjudaComandos;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        ^A: Begin
                                ponteiro := ponteiro + 15;
                                if ponteiro > tamanhoDicionario-4 then
                                    begin
                                        ponteiro := tamanhoDicionario-4;
        msgbaixo ('DCFIMTEX', 'Fim do texto');
sintclek;                                    end
                                else
sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^S, 's', 'S': begin FalaLivroAtual;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    'f', 'F': buscaPalavra;
    ^F: buscaDeNovo;
    'p', 'P': ProcuraVerbete;
    ^P: buscaDeNovoPal;
    't', 'T': BuscaPalavraFrente;
    ^T: buscaDeNovo;

    'g', 'G': begin VaiparaLivro;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^G: begin
begin
    consisteDirArq;
    gravaAsProcuras := not gravaAsProcuras;
    if gravaAsProcuras then
        msgbaixo ('DCGRAVAN', 'Gravando as procuras')
    else
        msgbaixo ('DCSEMGRA', 'Sem gravar as procuras');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        {msgbaixo ('DCFIMTXT', 'Fim do texto');}
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
begin
      If codlivro = 26  then
begin
 px:=1;
  If py = 7  Then
 begin
    If ponteiro-1< tamanhoDicionario-14 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
begin
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
            break;
end;
end
  Else inc(py);
end
else
begin
 px:=1;
  If py = 11  Then
begin
    If ponteiro< tamanhoDicionario-12 then
        begin
            inc ( ponteiro );
            px := 1;
        end
    Else
        msgbaixo ('DCFIMTEX', 'Fim do texto');
end
  Else inc(py);
end;
end;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

    ^H, 'h', 'H': begin VaiParaCapitulo;
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

     'j', 'J': begin  VaiparaMarca;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^J: begin MarcaLivro;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    'v', 'V': AvancaNumber;

                    ^V: begin FalaVersao;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    ^M, 'm', 'M': begin Setabaixo;
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

                    ^R, 'r', 'R': VoltaNumber;

        ^L, 'l', 'L': begin Poslinha;
if not keypressed then
posColuna;
end;

        ^K, 'k', 'K': begin PosColuna;
if not keypressed then
posLinha;
end;

        ^U, 'u', 'U': Begin
                                ponteiro := ponteiro - 10;
                                if ponteiro < 10 then
                                    begin
                                        ponteiro := 3;
        msgbaixo('DCINIBIB', 'Incio do Dicionrio ');
sintclek;
                                    end
                                else
sintclek;
py :=1;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

        ^N, 'n', 'N': Begin
                                ponteiro := ponteiro + 10;
                                if ponteiro > tamanhoDicionario-4 then
                                    begin
                                        ponteiro := tamanhoDicionario-7;
        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
sintclek;                                    end
                                else
sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

    'x', 'X': begin pulaCapitulo;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^E, 'e', 'E': begin voltaCapitulo;
  falanumeroconv(numeroparastring(capituloatual), 0);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

       ^C, 'c', 'C' : jogaAreaTransf (true);

    ^Z, 'z', 'Z': begin LivroPosterior;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^Q, 'q', 'Q': begin LivroAnterior;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'.', '>': begin FimLetra;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ^I, 'i', 'I': begin InicioCapitulo;
        msgbaixo('DCINICAP', 'Incio do captulo');
falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ',', '<': begin FimCapitulo;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    'o', 'O': begin IniLetra;
//falaLivroAtual1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'[', '{': begin IniBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

']', '}', '/', '?': begin FimBiblia;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        ^B, 'B', 'b': tratabloco;

                    { escape }
                    #27: ;
                    ^X: begin
delay (3);
    SintFim;
    doneWinCrt;
end;

        else { case }
               sintBip;
        End;

        str(capituloatual, numlivro);
    tituloler :=nomelivros^[codlivro]+' -PARTE-'+numlivro;
        escreveTelatexto;

    Until tecla = #27;   { escape }
  InicBloco;
  msgbaixo('DCFIMLEI', 'Livro fechado...');
end;

Procedure LeituraInfo;
var lendoContinuo: boolean;

        procedure processaContr;
var c: char;
    x : byte;
    salva: integer;
    n: integer;
    sf: string;
    apertouShift: boolean;

        Begin

    apertouShift := GetKeyState(VK_SHIFT) < 0;
    if ((not apertouShift) and (tecla <> DEL)) or
       (tecla in [ALTF1, F3, F5, CTLF5, F6, CTLF6, F7, CTLF7, F9, F10,
        CTLPGUP, CTLPGDN, CIMA, BAIX, PGUP, PGDN]) then
        begin
            iniMarca := 0;
            fimMarca := 0;
        end
    else
        begin
            if iniMarca <= 0 then
                iniMarca := px;
        end;

            tecla := readkey;
            Case tecla of

                F1: falaPalavra;

    CTLF1: begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF2: begin
c := '3';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF3: begin
c := '4';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

CTLF4: begin
c := '5';
        begin
            sintFim;
            sintInic (ord(c) - ord('0'), sintambiente ('DICVOX', 'DIRDICVOX'));
end;
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

                ^F: begin
                        While Not Keypressed  Do
                        Begin
                          If ponteiro > TamanhoInfo-5  Then Exit;
                          falalinha(false);
                          If px >= Length (texto[py])  Then px :=1;
                          inc(ponteiro);
                          escrevetelatexto;
                        end;
                        while Keypressed  Do tecla := readkey;
                        tecla :=#255;
                     end;

                F4: begin Paramsintese;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

                F5: buscaCadeia;

                CTLF5: buscaNovamente;

                F8: FalaHora;

                CTLF8: FalaDia;

    F11: begin
begin
    sintFalaPont := not sintFalaPont;
    if sintFalaPont then
        msgbaixo ('DCPONACI', 'Com pontos')
    else
        msgbaixo ('DCPONDLG', 'Sem pontos');
end;
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;

                INS:
 begin
  ponteiro := 1;
py :=1;
px :=1;
        msgbaixo ('DCINITEX', 'Incio do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

        CTLDIR:  begin
                     salva := px;
                     palavraDir (true);
                     n := px-salva;
                     sf := copy (texto[py], salva, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;
        CTLESQ:  begin
                     salva := px;
                     palavraEsq (true);
                     n := salva-px;
                     sf := copy (texto[py], px, n);
                     if trim (sf) = '' then
                         sintclek
                     else
                         sintetiza (sf);
                 end;

                DIR: setadir;

                ESQ: setaesq;

                CIMA: begin Setacima1;
if not keypressed then
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

                BAIX: begin Setabaixo1;
if not keypressed then
px :=1;
  textoBuscado := '';
  seek(arquivo,ponteiro +py-1);
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
 px:=2;
atualizaporindice;
                  letrecho;
                     escreveTelatexto;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
    If px <= length (trim (texto [py])) Then
                        sintetiza (texto [py])
else
sintbip;
 end;

                    #113: VoltaNumberInfo;

                    #114: AvancaNumberInfo;

                HOME: Begin
                     px := 1;
                    sintbip;
                    end;

                TEND: Begin
                    px := length (trim ( texto [py]))+1;
                    sintbip;
                        end;

                    PGUP: begin sintclek; VoltaNumbersInfo; end;
                     PGDN: begin sintclek; AvancaNumbersInfo; end;

CTLPGUP, CTLHOME:
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('DCINITEX', 'Incio do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

CTLPGDN, CTLEND, DEL:
 begin
  ponteiro := TamanhoInfo-2;
py :=1;
px :=1;
        msgbaixo ('DCFIMTEX', 'Fim do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                else  { of case }
                    sintBip;
            end;

    if apertouShift then
         fimMarca := px;

        End;


begin
    TituloLer := '                    - INFORMAES SOBRE A BBLIA -                     ';
    gotoxy(2,24); write(barrainfo);
    escreveTelaTexto;
                        sintetiza (texto[py]);
    repeat
            gotoxy (px, 09+py);
        tecla := readkey;
                Case tecla Of
                    #0:  processaContr;


                    ^V: begin FalaVersao;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    'v': AvancaNumberInfo;
                    'r': VoltaNumberInfo;

                    'V': begin sintclek; AvancaNumbersInfo; end;
                    ^R, 'R': begin sintclek; VoltaNumbersInfo; end;

                    ^L, 'l', 'L': begin PosLinha1;
PosColuna;
end;

                    ^K, 'k', 'K': begin PosColuna;
PosLinha1;
end;

        ^U, 'u', 'U': Begin
                                ponteiro := ponteiro - 10;
                                if ponteiro < 10 then
                                    begin
                                        ponteiro := 1;
        msgbaixo ('DCINITEX', 'Incio do texto');
sintclek;
                                    end
                                else
sintclek;
py :=1;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

^N, 'n', 'N': begin
                                ponteiro := ponteiro + 10;
                                if ponteiro > TamanhoInfo-2 then
                                    begin
                                        ponteiro := TamanhoInfo-2;
        msgbaixo ('DCFIMTEX', 'Fim do texto');
sintclek;                                    end
                                else
sintclek;
px :=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    ^M, 'm', 'M': begin Setabaixo;
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

    ' ': begin
                    iniciaLeitura := not iniciaLeitura;
if iniciaLeitura then
        begin
        if getKeyState (vk_Menu) < 0 then
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break;
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end
        else
             begin
                 lendoContinuo := true;
                 repeat
    If ponteiro= TamanhoInfo-2 then
begin
        msgbaixo ('DCFIMTEX', 'Fim do texto');
            break
end
else
                     setabaixo1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                     escreveTelatexto;
                     atualizaporindice;
                     if keypressed then lendoContinuo := false;
                 until not lendoContinuo;
             end;
             end;
             end;

      ^A, 'a', 'A':   sintsom('DCLEINFO');

        ^B, 'B', 'b': tratablocoInfo;

       ^C, 'c', 'C' : jogaAreaTransf (true);

    'f', 'F', 't', 'T': buscaCadeia;
    ^F, ^T: buscanovamente;

^O, 'O', 'o':
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('DCINITEX', 'Incio do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

^P, 'p', 'P':
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('DCINITEX', 'Incio do Texto');
//sintclek;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'[', '{':
 begin
py :=1;
px :=1;
  ponteiro := 1;
        msgbaixo ('DCINITEX', 'Incio do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

'/', '?':
 begin
  ponteiro := TamanhoInfo-2;
py :=1;
px :=1;
        msgbaixo ('DCFIMTEX', 'Fim do texto');
{sintclek;}
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
end;

                    { escape }
                    #27: ;
                    ^X: begin
    SintFim;
    doneWinCrt;
end;

                else { case }
                       sintBip;
                End;

                escreveTelatexto;

    Until tecla = #27;   { escape }
  InicBloco;
  msgbaixo('DCFIMLEI', 'Livro fechado...');
end;

end.
