{ rotinas de tratamento de funcoes do editor }
{ Autores: Marcelo Luis Pinheiro }
{ Orientador Academico: Jose' Antonio Borges }
{ Em 10/12/93 }

Unit DicBusca;

interface
uses
    DVcrt, Windows, DVWin, DicLer, sysUtils,
    Dicvars, Dicsom, Dicfun, DicBloco, dvlenum;

Procedure palavraDir (falando: boolean);
Procedure palavraEsq (falando: boolean);
Procedure buscaRebusca;
Procedure ProcuraVerbete;
Procedure AvancaNumber;
Procedure VoltaNumber;
Procedure AvancaNumberInfo;
Procedure VoltaNumberInfo;
Procedure AvancaNumbersInfo;
Procedure VoltaNumbersInfo;
Procedure buscaPalavra;
Procedure buscaPalavraFrente;
Procedure buscaCadeia;
Procedure buscaCadeiaVerbete;
Procedure buscaDeNovo;
Procedure buscaDeNovoPal;
Procedure buscaDeNovo1;
Procedure buscaNovamente;
Procedure buscaNovamentePal;

implementation

var
    sz: array [0..144] of char;

{--------------------------------------------------------}

Procedure palavraDir (falando: boolean);
var
    linha: string;
    tam: integer;
    c: char;
begin
    tam := length (texto [py]);
    linha := texto [py] + ' x';

    c := linha[px];
    if c <> ' ' then
        repeat
            px := px + 1;
            c := linha[px];
        until not (c in ['a'..'z', 'A'..'Z', '0'..'9', #128..#255]);

    if c = ' ' then
        repeat
            px := px + 1;
            c := linha[px];
        until c <> ' ';

    if px > tam+1 then
        begin
            px := tam+1;
            if falando then sintBip;
        end
    else
        if falando then sintClek;
end;

{--------------------------------------------------------}

Procedure palavraEsq (falando: boolean);
var
    linha: string;
    c: char;
begin
    linha := ' x' + texto [py];
    px := px + 2;

    repeat
        px := px - 1;
        if px <= length (linha) then
            c := linha[px]
        else
            c := ' ';
    until c <> ' ';

    repeat
        px := px - 1;
        c := linha[px];
    until not (c in ['a'..'z', 'A'..'Z', '0'..'9', #128..#255]);

    px := px - 1;

    if px <= 0 then
        begin
            px := 1;
            if falando then sintBip;
        end
    else
        if falando then {sintClek};

end;

{--------------------------------------------------------}

procedure maiuscula (var s: Linha);
var c: char;
    i: integer;
begin
    for i := 1 to length (s) do
        begin
            c := s[i];
            if c < #128 then
                c := upcase (c)
            else
                case c of
                    '': c := '';
                    '': c := '';
                    '': c := '';    { provisorio }
                    '' : c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';    { provisorio }
                    '': c := '';
                    '': c := '';
                    '': c := '';    { provisorio }
                    'u': c := 'U';    { provisorio }
                    '': c := '';
                end;
            s[i] := c;
        end;
end;

{-----------------------------}

Procedure buscaRebusca;
var x : byte;
k, i, y: integer;
arquiBloco, dirGrava, s, s1: string;
a: text;
    textoAProcurar: string;
    c: char;

label denovo;
begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    msgbaixo ('DCTXTPRC', 'Digite o texto a procurar');
    sintetiza (textoBuscado);
    begin
    c := sintEdita (textoBuscado, wherex, wherey, 255, true);
    textoBuscado := maiuscAnsi (textoBuscado);
    writeln;
sintclek;

    if textoBuscado = '' then
    textoBuscado := textoAProcurar;
            strPCopy (sz, textoBuscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=1;
                exit;
end;

    if textoBuscado = '' then
        begin
textoBuscado := textoAProcurar;
buscadenovo;
//                msgbaixo('DCDESIST', 'Operao cancelada');
            exit;
        end
else

ponteiro:=3;

  seek(arquivo,ponteiro +py-1);
Limite := tamanhoDicionario;

                    dirGrava := sintAmbiente ('DICVOX', 'DIRGRAVA');
                    if dirGrava = '' then dirGrava := 'C:\Winvox\treino';
                    if dirGrava [length(dirGrava)] <> '\' then
                        dirGrava := dirGrava + '\';

    s1 := sintAmbiente ('DICVOX', 'DICATU');
    if s1 = 'A' then
    begin
s1 := ('A - Dicionrio Jurdico de Latim');
    end;

    if s1 = 'B' then
    begin
s1 := ('B - Dicionrio da Bblia de Almeida');
    end;

    if s1 = 'C' then
    begin
s1 := ('C - Dicionrio de Sociologia');
    end;

    if s1 = 'D' then
    begin
s1 := ('D - Espanhol - Portugus - Espanhol');
    end;

    if s1 = 'E' then
    begin
s1 := ('E - Espanhol - Espanhol');
    end;

    if s1 = 'F' then
    begin
s1 := ('F - Francs - Portugus - Francs');
    end;

    if s1 = 'G' then
    begin
s1 := ('G - Dicionrio de Grego com Concordncia em grego nas informaes');
    end;

    if s1 = 'H' then
    begin
s1 := ('H - Dicionrio de Hebraico com Concordncia em hebraico nas informaes');
    end;

    if s1 = 'I' then
    begin
s1 := ('I - Ingls - Portugus - Ingls');
    end;

    if s1 = 'J' then
    begin
s1 := ('J - Dicionrio Jurdico Brasileiro');
    end;

    if s1 = 'K' then
    begin
s1 := ('K - Dicionrio de Eletrnica em espanhol');
    end;

    if s1 = 'L' then
    begin
s1 := ('L - Dicionrio de Filosofia');
    end;

    if s1 = 'M' then
    begin
s1 := ('M - Dicionrio de significado e origem dos nomes');
    end;

    if s1 = 'N' then
    begin
s1 := ('N - Dicionrio de Informtica');
    end;

    if s1 = 'O' then
    begin
s1 := ('O - Oxford');
    end;

    if s1 = 'P' then
    begin
s1 := ('P - Dicionrio de Portugus');
    end;

    if s1 = 'Q' then
    begin
s1 := ('Q - Dicionrio de Significados');
    end;

    if s1 = 'R' then
    begin
s1 := ('R - Dicionrio de Origem da Palavra');
    end;

    if s1 = 'S' then
    begin
s1 := ('S - Ingls - Espanhol');
    end;

    if s1 = 'T' then
    begin
s1 := ('T - Italiano - Portugus - Italiano');
    end;

    if s1 = 'U' then
    begin
s1 := ('U - Dicionrio de psicologia');
    end;

    if s1 = 'V' then
    begin
s1 := ('V - Alemo - Portugus');
    end;

    if s1 = 'W' then
    begin
s1 := ('W - Webster');
    end;

    if s1 = 'X' then
    begin
s1 := ('X - Esperanto - Portugus');
    end;

    if s1 = 'Y' then
    begin
s1 := ('Y - Vocabulrio Ortogrfico da Lngua Portuguesa (VOLP)');
    end;

    if s1 = 'Z' then
    begin
s1 := ('Z - Dicionrio de Qumica');
    end;

    if s1 = '1' then
    begin
s1 := ('1 - Portugus - Ingls - Portugus');
    end;

    if s1 = '2' then
    begin
s1 := ('2 - Dicionrio de Grego em portugus, com Concordncia em grego nas informaes');
    end;

    if s1 = '3' then
    begin
s1 := ('3 - Dicionrio de Hebraico em portugus, com Concordncia em hebraico nas informaes');
    end;

    if s1 = '4' then
    begin
s1 := ('4 - Portugus - Espanhol - Portugus');
    end;

    if s1 = '5' then
    begin
s1 := ('5 - Latim - Ingls - Latim');
    end;

    if s1 = '6' then
    begin
s1 := ('6 - Ingls - Latim - Ingls');
    end;

    if s1 = '7' then
    begin
s1 := ('7 - Portugus - Italiano - Portugus');
    end;

    if s1 = '8' then
    begin
s1 := ('8 - Etimolgico - Origem das Palavras');
    end;

    if s1 = '9' then
    begin
s1 := ('9 - Dicionrio Bblico da Torre de Vigia');
    end;

    if s1 = '0' then
    begin
s1 := ('0 - Dicionrio de Origem da Palavra');
    end;

k:=-1;
i:=-1;
denovo:
if k = 50 then
begin
k:=k-50;
end;
k:=k+1;
i:=i+1;
            str (i, s);

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
//                  letrecho;
gravaProcura;
if k = 50 then
sintbip;
goto denovo;
                end;
        end;

begin
arquiBloco := dirGrava + '0 ' + textoBuscado + ' Dicionrio ' + s1 + '.TXT';
//arquiBloco := dirGrava + '0 ' + textoBuscado + '.TXT';
  arquibloco :=limpa(  arquiBloco );

             assign (a, arquibloco);
             {$i-} reset (a); {$i+}
             If ioresult = 0 then
             begin
                 close (a);

begin
assign(a, arquibloco);
{$I-} append(a);{$I+}
If IOresult <> 0  Then
    begin
    exit;
    {$I-}close(a);{$I+}
    end;

if i = 1 then
begin
            textoBuscado :=maiuscansi (limpa(textoBuscado));
    writeln(a, '');
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
    writeln(a, ''+ s+ ' ocorrncia das palavras '+'"'+textoBuscado+'".')
    else
    writeln(a, ''+ s+ ' ocorrncia da palavra '+'"'+textoBuscado+'".');
end;
end;

if i > 1 then
begin
            textoBuscado :=maiuscansi (limpa(textoBuscado));
    writeln(a, '');
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
    writeln(a, ''+ s+ ' ocorrncias das palavras '+'"'+textoBuscado+'".')
else
    writeln(a, ''+ s+ ' ocorrncias da palavra '+'"'+textoBuscado+'".');
end;
end;

end;
close(a);
end;
end;

                msgbaixo('DCBIP', 'Bip');

if i = 0 then
begin
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
                msgbaixo ('DCNENHUMS', 'Nenhuma ocorrncia das palavras:')
    else
                msgbaixo ('DCNENHUM', 'Nenhuma ocorrncia da palavra:');
end;
sintbip;
            textoBuscado :=maiuscansi (limpa(textoBuscado));
sintwriteln (' "' + textoBuscado + '".');
sintbip;
end;

if i = 1 then
begin
                msgbaixo ('DCUMA', 'Uma');
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
                msgbaixo ('DCOCOPA1S', ' ocorrncia das palavras:')
    else
                msgbaixo ('DCOCOPA1', ' ocorrncia da palavra:');
end;
sintbip;
            textoBuscado :=maiuscansi (limpa(textoBuscado));
sintwriteln (' "' + textoBuscado + '".');
sintbip;
end;

if i = 2 then
begin
                msgbaixo ('DCDUAS', 'Duas');
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
                msgbaixo ('DCOCOPALS', ' ocorrncias das palavras:')
    else
                msgbaixo ('DCOCOPAL', ' ocorrncias da palavra:');
end;
sintbip;
            textoBuscado :=maiuscansi (limpa(textoBuscado));
sintwriteln (' "' + textoBuscado + '".');
sintbip;
end;

if i > 2 then
begin
sintwriteint (i);
begin
                y := pos (' ', textoBuscado);
            if y > 0 then
                msgbaixo ('DCOCOPALS', ' ocorrncias das palavras:')
    else
                msgbaixo ('DCOCOPAL', ' ocorrncias da palavra:');
end;
sintbip;
            textoBuscado :=maiuscansi (limpa(textoBuscado));
sintwriteln (' "' + textoBuscado + '".');
sintbip;
end;

if i > 0 then
begin
                msgbaixo('DCVERRES', 'Veja o resultado no arquivo: ');
            textoBuscado :=maiuscansi (limpa(textoBuscado));
sintwriteln ( dirGrava + '0 ' + textoBuscado + ' Dicionrio ' + s1 + '.TXT');
//sintwriteln ( dirGrava + '0 ' + textoBuscado + '.TXT');
end;

        atualizaporindice;
falalivroatual1;
                  letrecho;
    salvaCurx := px;
    salvaCury := py;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
    px := salvaCurx;
    py := salvaCury;
{px:=x;}
exit;
end;
end;

{-----------------------------}

Procedure ProcuraVerbete;
var
    textoAProcurar: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

  gotoxy(2,8);
write(limpeza);
  gotoxy(10,8);
write('Digite o verbete a procurar? ');
msgbaixo('DCVERPRO', 'Digite o verbete a procurar');
    sintetiza (textoBuscado);
    begin
    c := sintEdita (textoBuscado, wherex, wherey, 255, true);
    textoBuscado := maiuscAnsi (textoBuscado);
write ('Digite o verbete a procurar : ');
//    writeln;
sintclek;

    if textoBuscado = '' then
    textoBuscado := textoAProcurar;
            strPCopy (sz, textoBuscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if textoBuscado = '' then
        begin
textoBuscado := textoAProcurar;
buscadenovo;
//                msgbaixo('DCDESIST', 'Operao cancelada');
            exit;
        end
else
  gotoxy(22, 16);
  textbackground(red);
  textcolor(white+blink);
  write ('Processando consulta no dicionrio...');
  textbackground(blue);
  textcolor(White);
  assign(arquivo, dadosDisco);
  {$I-} reset(arquivo); {$I+}
  If IOResult <> 0  Then
    begin
    msgbaixo('DCERRODT', 'Erro grave nos dados do sistema!');
    exit;
    end;
  textoBuscado := '# ' + textoBuscado;
  achou := false;
  While (not achou)and(filepos(arquivo)<tamanhoDicionario)  Do
    begin
    read(arquivo, linhateste);
    linhateste := maiuscansi(limpa(linhateste));
    achou :=pos(textoBuscado, linhateste) > 0;
end;
  If not achou  Then
    begin
                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXTNAO', 'Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
    exit;
    end;

                msgbaixo('DCBIP', 'Bip');
  sintsom('DCOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
gravaprocura;
                end;
        end;

{-----------------------------}

Procedure AvancaNumber;
var x : byte;
begin
  textoBuscado := '#';
  seek(arquivo,ponteiro +py);
Limite := tamanhoDicionario;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 3;
                    exit;
                end;
        end;

        msgbaixo('DCFIMBIB', 'Fim do Dicionrio');
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=3;
exit;
end;

{-----------------------------}

Procedure VoltaNumber;
var x : byte;
begin
  textoBuscado := '#';

Limite := tamanhoDicionario-tamanhoDicionario-1;

  while filepos(arquivo)> limite+3  Do
    begin
ponteiro := ponteiro - 1;
  seek(arquivo,ponteiro);
            read(arquivo, linhateste);
            x := pos (textoBuscado, linhateste);

            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 3;
                    exit;
                end;
                end;

if (ponteiro = 3) and (py=1) then
ponteiro := ponteiro + 1
else
ponteiro := ponteiro + 2;

  seek(arquivo,ponteiro);
    msgbaixo('DCINIBIB', 'Incio do Dicionrio ');
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
if pontaux = 1 then
                    px :=3
else
                    px :=1;
exit;
end;

{-----------------------------}

Procedure AvancaNumberInfo;
var x : byte;
begin
  textoBuscado := '#';

  seek(arquivo,ponteiro +py);
Limite := TamanhoInfo;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=3;
exit;
end;
        end;

        msgbaixo ('DCFIMTEX', 'Fim do texto');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=3;
exit;
end;

{-----------------------------}

Procedure VoltaNumberInfo;
var x : byte;
begin
  textoBuscado := '#';

Limite := tamanhoInfo-tamanhoInfo;

  while filepos(arquivo)> limite+3  Do
    begin
ponteiro := ponteiro - 1;
  seek(arquivo,ponteiro);
            read(arquivo, linhateste);
            x := pos (textoBuscado, linhateste);

            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px :=3;
exit;
end;
end;

ponteiro := ponteiro+2;
  seek(arquivo,ponteiro);
        msgbaixo ('DCINITEX', 'Incio do texto');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    py :=1;
px :=3;
exit;
end;

{-----------------------------}

Procedure AvancaNumbersInfo;
var x : byte;
begin
  textoBuscado := '##';

  seek(arquivo,ponteiro +py);
Limite := TamanhoInfo;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 4;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 4;
                    exit;
                end;
        end;

        msgbaixo ('DCFIMTEX', 'Fim do texto');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=4;
exit;
end;

{-----------------------------}

Procedure VoltaNumbersInfo;
var x : byte;
begin
  textoBuscado := '##';

Limite := tamanhoInfo-tamanhoInfo;

  while filepos(arquivo)> limite+2  Do
    begin
ponteiro := ponteiro - 1;
  seek(arquivo,ponteiro);
            read(arquivo, linhateste);
            x := pos (textoBuscado, linhateste);

            if x > 0 then
                begin
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 4;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px := 4;
                    exit;
                end;
                end;

ponteiro := ponteiro+2;
  seek(arquivo,ponteiro);
        msgbaixo ('DCINITEX', 'Incio do texto');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    py :=1;
                    px :=4;
exit;
end;

{-----------------------------}

Procedure buscaPalavra;
var x : byte;
    textoAProcurar: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    msgbaixo ('DCTXTPRC', 'Digite o texto a procurar');
    msgbaixo ('DCPRCINI', ' Desde o incio do dicionrio');
    sintetiza (textoBuscado);
    begin
    c := sintEdita (textoBuscado, wherex, wherey, 255, true);
    textoBuscado := maiuscAnsi (textoBuscado);
    writeln;
sintclek;

    if textoBuscado = '' then
    textoBuscado := textoAProcurar;
            strPCopy (sz, textoBuscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if textoBuscado = '' then
        begin
textoBuscado := textoAProcurar;
buscadenovo;
//                msgbaixo('DCDESIST', 'Operao cancelada');
            exit;
        end
else

ponteiro:=3;

  seek(arquivo,ponteiro +py-1);
Limite := tamanhoDicionario;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    Sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;
end;

{-----------------------------}

Procedure buscaPalavraFrente;
var x : byte;
    textoAProcurar: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    msgbaixo ('DCTXTPRC', 'Digite o texto a procurar');
    msgbaixo ('DCPRCFRE', ' Deste ponto para a frente');
    sintetiza (textoBuscado);
    begin
    c := sintEdita (textoBuscado, wherex, wherey, 255, true);
    textoBuscado := maiuscAnsi (textoBuscado);
    writeln;
sintclek;

    if textoBuscado = '' then
    textoBuscado := textoAProcurar;
            strPCopy (sz, textoBuscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if textoBuscado = '' then
        begin
textoBuscado := textoAProcurar;
buscadenovo;
//                msgbaixo('DCDESIST', 'Operao cancelada');
            exit;
        end
else

  seek(arquivo,ponteiro +py-1);
Limite := tamanhoDicionario;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    Sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;
end;

{-----------------------------}

Procedure buscaCadeia;
var x : byte;
    textoAProcurar: string;
    c: char;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado := textoAProcurar;

  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    msgbaixo ('DCTXTPRC', 'Digite o texto a procurar');
    sintetiza (textoBuscado);
    begin
    c := sintEdita (textoBuscado, wherex, wherey, 255, true);
    textoBuscado := maiuscAnsi (textoBuscado);
    writeln;
sintclek;

    if textoBuscado = '' then
    textoBuscado := textoAProcurar;
            strPCopy (sz, textoBuscado);
            writePrivateProfileString('EDIVOX', 'TEXTOPROCURADO',     sz, 'DOSVOX.INI');

    if c = ESC then
        begin
                msgbaixo ('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
end;

    if textoBuscado = '' then
        begin
textoBuscado := textoAProcurar;
buscadenovo;
//                msgbaixo ('DCDESIST', 'Operao cancelada');
            exit;
        end
else

  seek(arquivo,ponteiro +py-1);
Limite := TamanhoInfo;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo ('DCBIP', 'Bip');
{                    msgbaixo ('DCTXTENC', 'Texto encontrado');}
  msgbaixo ('DCOK', 'Ok');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := x;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
                    exit;
                end;
        end;

                msgbaixo ('DCBIP', 'Bip');
    msgbaixo ('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=1;
exit;
end;
end;

{-----------------------------}

Procedure buscaCadeiaVerbete;
var x : byte;
begin
  gotoxy(2,8); write(limpeza);
  gotoxy(10,8); write('Qual o texto a procurar : ');
    msgbaixo ('DCTXTPRC', 'Digite o texto a procurar');
    msgbaixo ('DCPRCFRE', ' Deste ponto para a frente');
  textoBuscado :=maiuscansi(limpa( lelinha));
sintclek;
        if textoBuscado = '' then
            begin
                msgbaixo('DCDESIST', 'Operao cancelada');
    gotoxy(2,8); write(limpeza);
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
                exit;
            end;
  textoBuscado := '# ' + textoBuscado;

  seek(arquivo,ponteiro +py-1);
Limite := TamanhoInfo;

  while filepos(arquivo)< limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
  sintsom('DCOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=3;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=3;
exit;
end;

{-----------------------------}

Procedure buscaDeNovo;
var  x: byte;
    textoAProcurar: string;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado:= textoAProcurar;

            x := pos (' ', textoBuscado);
            if x = 0 then
            textoBuscado := (' ' + textoBuscado + ' ');

sintclek;
limite := tamanhoDicionario;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
        atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
gravaprocura;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaDeNovoPal;
var  x: byte;
begin
sintclek;
limite := tamanhoDicionario;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro :=filepos(arquivo)-1;
    py:=1;
                    px := 3;
    atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
                    px :=x;
gravaprocura;
px:=3;
    exit;
end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
px:=3;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=3;
end;

{-----------------------------}

Procedure buscaDeNovo1;
var  x: byte;
begin
sintclek;
limite := tamanhoDicionario;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
        atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaNovamente;
var  x: byte;
    textoAProcurar: string;

begin
    textoAProcurar := sintAmbiente ('EDIVOX', 'TEXTOPROCURADO');
    if textoAProcurar = '' then
        begin
            textoAProcurar := '';
        end;

    textoBuscado:= textoAProcurar;

            x := pos (' ', textoBuscado);
            if x = 0 then
            textoBuscado := (' ' + textoBuscado + ' ');

sintclek;
limite := TamanhoInfo;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo ('DCBIP', 'Bip');
{                    msgbaixo ('DCTXTENC', 'Texto encontrado');}
  msgbaixo ('DCOK', 'Ok');
                    ponteiro := filepos(arquivo)-1;
                    px := x;py:=1;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=x;
                    exit;
                end;
        end;

                msgbaixo ('DCBIP', 'Bip');
    msgbaixo ('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=1;
end;

{-----------------------------}

Procedure buscaNovamentePal;
var  x: byte;
begin
sintclek;
limite := tamanhoDicionario;
    while filepos(arquivo)<limite  Do
        begin
            read(arquivo, linhateste);
            linhateste:=maiuscansi (limpa(linhateste));
            x := pos (textoBuscado, linhateste);
            if x > 0 then
                begin
                msgbaixo('DCBIP', 'Bip');
{                    sintsom('DCTXTENC');}
  sintsom('DCOK');
                    ponteiro := filepos(arquivo)-1;
                    px := 3;py:=1;
        atualizaporindice;
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=3;
                    exit;
                end;
        end;

                msgbaixo('DCBIP', 'Bip');
    msgbaixo('DCTXNENC','Texto no encontrado');
                  letrecho;
if primeiraLetra (sintAmbiente ('DICVOX', 'SAPIATIVADO')) = 'S' then
falaLinha (true)
else
                        sintetiza (texto [py]);
px:=3;
end;

begin
    textoBuscado := '#';
end.
