Unit Dicvars;

Interface

Type
    DataLinha=record
        l, c : Byte;
        end;

    TipoNomeLivro = String[18];

    VetorNomeLivros = array[0..27]of TipoNomeLivro;

    Arquilinha =File of Datalinha;

    Linha = String[78];
    Vetor = Array[1..11]of Linha;

var
    tituloJan: array [0..100] of char;
    somlivro : string[5];
    nomeLivros : ^VetorNomeLivros;
    NumeroCap:array[1..26]of integer;
    indice : Array[0..27] of LongInt;
    TamanhoLetraZ: Integer;
    InicioUltimaParte: Integer;
    Dislinha : Datalinha;
    quelinha : arquilinha;
    erro : Integer;
    gravaAsProcuras: boolean;               { Grava as procuras}
    dirGravaProcuras: boolean;               { Grava as procuras}
    numlivro, versiculo, tituloLer, titulolerinibloco: string;
    achou : boolean;
    linhateste, linhateste0 : Linha;
    texto : Vetor;
    Codlivro, px, py, paux, capituloatual, aux : Integer;
    ponteiro, pontaux, limite, tamanhoDicionario, TamanhoInfo, SalvaTamBib, SalvaTamInf : LongInt;
    Livro, capitulo : Linha;
    arquivo : File of Linha;
    nomearquivo, saida : Linha;
    Inibloco, Fimbloco : LongInt;
    iniMarca, fimMarca, novoIni : LongInt;
    Textoprocura, buscado : Linha;
    textoBuscado: string;
    ArquiMarca : File of LongInt;
    Marca : Array['0'..'9']of LongInt;
    tecla, resp, opc, lixo : char;
    salvaCurx,                   { posicao salva do cursor }
    salvaCury: integer;
    extPadrao: string;           { extenso padro do arquivo}
    arqIni: string;
    velGeral, confTipoSapi, confNum, confVeloc, confTonal: integer;
    comSapi: boolean;

var
    DadosDisco, DadosLinhas, DadosInfo, dadosMarca, dirDados: string [80];

const
    ctlEnd = #117;
    ctlHome = #119;
    blink = 16;

    Limpeza ='                                                                              ';
    consultar='              Qual o tipo de consulta ? ';
    BarraMenu = '         Tecle a letra em destaque ou |F1| para ajuda         ';
    BarraInfo ='          Use as setas e controles para andar no texto.  ESC termina          ';
    BarraSelec = 'Use os controles para escolher o livro, depois <ENTER>';
    Barraleitura = '   F5 - Acha texto  F6 - Troca Livro  F7 - Troca capitulo  F9 / F10 - Marcas  ';

Procedure Limpabaixo;
Procedure Molduratela;
Procedure MsgBaixo(s:String; m:String);
Procedure Letrecho;
function primeiraLetra (s: string): char;
Function selecionalivro(x,y:byte):byte;
Function Limpa(s:string):string;
Procedure LeMarcadores;
Procedure GravaMarcadores;
Procedure AjudaComandos;

Implementation
uses DVcrt,  DVWin, Windows, SysUtils, dicsint;

Const textoHelp:array[1..14]of string=(
'F1 - Comandos normais de fala',
'F2 - Informa letra e parte atuais',
'F4 - Comando para alterar modo de fala',
'F5 - Procura de palavra ou texto',
'F6 - Seleciona nova letra',
'F7 - Seleciona nova parte, dentro da letra atual',
'F8 - Informa a hora do sistema',
'F9 - Posiciona em uma das 10 marcas',
'F10 - Coloca posio atual em uma das 10 marcas',
'PGUP - Posiciona na letra anterior',
'PGDN - Posiciona na letra posterior',
'CTRL - PGUP - Posiciona na parte anterior',
'CTRL - PGDN - Posiciona na parte posterior',
'INSERT - Posiciona no incio do dicionrio');

Function limpa(s:string):string;
var achoubranco : Boolean; i:Byte;
begin
while (length(s)>0)and(s[1] = ' ')  do delete(s,1,1);
  while (length(s)>0)and(s[length(s)]=' ')  Do delete(s,length(s),1);
  achoubranco := false;
  i:=1;
  While i< Length(s)  Do begin
        inc(i);
    If s[i]=' '  Then
    If achoubranco  Then
        begin
        delete(s,i,1);
        dec(i);
        end
        Else achoubranco :=true
    Else achoubranco := false;
    end;

limpa :=s;
end;

Procedure LimpaBaixo;
var j : byte;
begin
for j:=7 to 22 do
 begin
    gotoxy(2,j);
    write(limpeza);
 end;
 gotoxy(2, 24);
 write(limpeza);
end;

Procedure msgBaixo;
begin
textbackground(red);
textcolor(white);
highvideo;
gotoxy(2, 24);
write(limpeza);
gotoxy(40-length(m)div 2, 24);
write(m);
sintsom(s);
normvideo;
//textcolor(WHITE);
//textbackground(BLACK);
textcolor(CYAN);
textbackground(MAGENTA);
gotoxy(2,24);
write(limpeza);
end;

Procedure MolduraTela;
var j: byte;
begin
textcolor(white);
gotoxy(1,1);
write('+');
for j:=2 to 79 do write('-');
write('+', '');
for J:=1 to 23  do
  begin
  gotoxy(80, j+1);
  write('', '');
  end;
gotoxy(1,25);
write('+');
For j:=2 to 79  Do write('-');
gotoxy(1,6);
write('+');
for j:=2 to 79 do write('-');
write('');
gotoxy(1,23); write('+');
for j:=2 to 79  do write('-');
write('');
{mem[$B800:3998]:=217;}
textcolor(White);
end;

Procedure Letrecho;
var fori:Byte;
begin
pontaux:= ponteiro ;
If pontaux < 0  then pontaux:=0;
   seek(arquivo, pontaux);
    ponteiro := pontaux;
for fori := 1 to 11 do
  read(arquivo, texto[fori]);
end;

function primeiraLetra (s: string): char;
begin
    s := trim (s);
    delete (s, 2, 999);
    if s = '' then primeiraLetra := ' '
              else primeiraLetra := upcase (s[1]);
end;

Function SelecionaLivro(x,y:Byte) : Byte;
var i : Byte;
Begin
  Case codlivro of
    0 : codlivro := 1;
    27 : codlivro :=26;
    end;

  i:=codlivro;
  resp :=#255;
  while resp <> #$0D  Do
    begin
    gotoxy(x,y);
    textbackground(red);
    write(nomelivros^[i]);
    textbackground(BLACK);
    str ( i, somlivro);
    if length(somlivro) = 1  then somlivro :='DC0' + somlivro
        Else somlivro := 'DC' + somlivro;
    sintsom(somlivro);
    resp := readkey;
    If resp = #0  Then
      resp :=readkey;
    Case resp of
        cima : begin If i > 1  Then dec(i); sintclek; end;
        baix : begin If i < 26  Then inc(i); sintclek; end;
        Enter : begin  SelecionaLivro :=i; sintclek; end;
        ESC : Begin
              SelecionaLivro :=0;
              exit;
              end;
        PGDN : If i < 22  then i:=i+5  Else i:=26;
        PGUP : If i > 6 then i :=i-5 Else i:=1;
        HOME : i :=1;
        TEND : i := 26;
        Else sintbip;
        end;
    end;
end;

{--------------------------------------------}

Procedure LeMarcadores;
var fori: Char;
begin
  assign(arquiMarca, dadosmarca);
{$i-}  reset(arquimarca);{$i+}
  If IOresult<> 0  Then
    begin
    msgbaixo('DCARQPER', 'Arquivo de marcadores perdido !');
  for fori:='0' to '9' Do marca[fori]:=3;
    exit;
    end;
  for fori:='0'  to '9'  do read(arquimarca, marca[fori]);
  close(arquimarca);
  end;

{------------------------------}

Procedure GravaMarcadores;
var indMarca: Char;
begin
  assign(arquimarca, dadosmarca);
  {$I-} rewrite(arquimarca);  {$I+}
  if ioresult <> 0 then exit;
  for indMarca := '0'  to  '9'  Do
    write(arquimarca, marca[indMarca]);
  close(arquimarca);
end;

procedure AjudaComandos;
var i : Byte;
    c: String;
begin
  limpabaixo;
  gotoxy(15,8); write('Comandos para leitura do Dicionrio:');
  gotoxy(10,11); write('As teclas de funo so as seguintes :');
  sintsom('DCAJUDA2');
  for i:= 1 to 14  Do
    begin
    If keypressed then exit;
    str(i,c);
    gotoxy(2,13); write(limpeza);
    gotoxy(10,13); write(textohelp[i]);
    sintsom('DCAC'+c);
    end;
end;

begin
    new ( NomeLivros );
end.
